module Net (module Net) where

import ST
import TransSystem
import Relation


--- definition of net


class (Cpo s, Eq s) => State s where
    splus , sminus :: s -> s -> s


class  (Cpo t, Eq t) => Transition t


class  (State s, Transition t) => Net n s t where
    fwrd, bwrd ::   n s t -> t -> s

instance (State s, Transition t, Net n s t) => TransSystem n s t  where
       transition k = rel2st . tr 
	    where tr t s = let m = fwrd k t ; l = (s `sminus` m) `splus`  (bwrd k t)
			   in if (m .<. s) && (l .<. top) then [l] else []
--
       trans_set  k = range 								  
